﻿using System;
using System.Windows;
using Infragistics.Controls.Menus;
using Infragistics.Controls.Editors;
using System.Collections;

namespace RibbonInScrollViewer
{
    public class XamComboEditorTool : RibbonTool
    {
        private XamComboEditorToolControl _control;

        private void UpdateBindings()
        {
            if (this._control != null)
            {
                this._control.OnApplyTemplate();
            }
        }

        protected override RibbonToolBaseControl ResolveToolControl()
        {
            XamComboEditorToolControl control = new XamComboEditorToolControl(this);
            if (this._control == null)
            {
                this._control = control;
            }
            return control;
        }

        public IEnumerable ItemsSource 
        {
            get { return (IEnumerable)GetValue(ItemsSourceProperty); }
            set 
            { 
                SetValue(ItemsSourceProperty, value); 
                this.UpdateBindings(); 
            }
        }

        public static readonly DependencyProperty ItemsSourceProperty =
            DependencyProperty.Register("ItemsSource", typeof(IEnumerable),
            typeof(XamComboEditorTool), null);

        public String DisplayMemberPath { get; set; }

    }

    public class XamComboEditorToolControl : RibbonToolBaseControl, IRibbonControl
    {
        private XamComboEditor _combo;

        public XamComboEditorToolControl()
        {
            this.DefaultStyleKey = typeof(XamComboEditorToolControl);
        }

        public XamComboEditorToolControl(RibbonToolBase tool)
            : base(tool)
        {
            this.DefaultStyleKey = typeof(XamComboEditorToolControl);
        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this._combo = GetTemplateChild("XamComboEditor") as XamComboEditor;
            if (this._combo != null)
            {
                this._combo.ItemsSource = ((XamComboEditorTool)this.Tool).ItemsSource;
                this._combo.DisplayMemberPath = ((XamComboEditorTool)this.Tool).DisplayMemberPath;
            }
        }
    }
}
